﻿#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Outfile=FileCheck.exe
#AutoIt3Wrapper_Res_Description=FileCheck
#AutoIt3Wrapper_Res_Fileversion=1.0.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <SendMessage.au3>
#include <WinAPI.au3>
#include <WinAPIShellEx.au3>
#include <WindowsConstants.au3>

OnAutoItExitRegister('OnAutoItExit')
Opt('GUIOnEventMode', 1)

Global $sTitle = 'FileCheck'
Global $sVersion = '1.0.0.0'
Global $sDate = '06.10.2016'
Global $sDatafile = @ScriptDir & '\FileCheck.txt'

Global $aFileFolder, $iCount = 0, $aidFileCheck[1][3]

Global $hMainGui = GUICreate(StringFormat('%s v%3.3s', $sTitle, $sVersion), 730, 600, -1, -1) ; das Fenster erstellen
GUISetBkColor(0xEEEEEE) ; Hintergrundfarbe für das Fenster festlegen
GUISetIcon('shell32.dll', 23) ; Icon für das Fenster festlegen
GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseMainGui') ; Funktion die beim schließen des Fensters aufgerufen wird
_ReadDatafile() ; die Datei mit den Datei-Pfaden einlesen und Gui-Elemente erstellen
_CheckFileFolder() ; testen, ob die Pfade existieren
GUISetState(@SW_SHOW, $hMainGui) ; das Fenster anzeigen

Global $iMsg = _WinAPI_RegisterWindowMessage('SHELLCHANGENOTIFY') ; die Message bei Windows registrieren
GUIRegisterMsg($iMsg, 'WM_SHELLCHANGENOTIFY') ; das Fenster für den Empfang der Message registrieren
Global $g_iID = _WinAPI_ShellChangeNotifyRegister($hMainGui, $iMsg, $SHCNE_ALLEVENTS, BitOR($SHCNRF_INTERRUPTLEVEL, $SHCNRF_SHELLLEVEL, $SHCNRF_RECURSIVEINTERRUPT), @ScriptDir, 1) ; Windows mitteilen welches Verzeichnis überwacht werden soll
If @error Then ; wenn das fehlschlägt, dann...
	MsgBox(BitOR($MB_ICONERROR, $MB_SYSTEMMODAL), 'Fehler', '"ShellChangeNotifyRegister" ist fehlgeschlagen.')
	Exit ; Programm mit Fehlermeldung beenden
EndIf

While Sleep(250) ; in einer Endlosschleife immer 250 ms warten und danach die Pfade auf Existenz testen
	_CheckFileFolder()
WEnd

Func WM_SHELLCHANGENOTIFY($hWnd, $iMsg, $wParam, $lParam)
	#forceref $hWnd, $iMsg
	; diese Funktion wird aufgerufen, wenn sich im überwachten Verzeichnis (@ScriptDir) eine Datei ändert
	Local $sPath = _WinAPI_ShellGetPathFromIDList(DllStructGetData(DllStructCreate('dword Item1; dword Item2', $wParam), 'Item1'))
	; wenn die geänderte Datei mit der Datendatei übereinstimmt, dann...
	If $sPath = $sDatafile Then _ReadDatafile() ; die Datei mit den Datei-Pfaden einlesen und Gui-Elemente neu erstellen
EndFunc   ;==>WM_SHELLCHANGENOTIFY

Func _CloseMainGui()
	If MsgBox(4 + 32 + 256, $sTitle, 'Soll das Programm wirklich beendet werden?', 0, $hMainGui) = 7 Then Return
	Exit
EndFunc   ;==>_CloseMainGui

Func OnAutoItExit()
	If $g_iID Then _WinAPI_ShellChangeNotifyDeregister($g_iID)
EndFunc   ;==>OnAutoItExit

Func _CheckFileFolder()
	For $i = 0 To $iCount - 1 ; Schleife, um alle Pfade aus der Datendatei durchzugehen
		If FileExists($aFileFolder[$i]) Then ; wenn der Pfad existiert, dann...
			If BitAND(GUICtrlGetState($aidFileCheck[$i][2]), $GUI_DISABLE) Then ; wenn der Button deaktiviert ist, dann...
				GUICtrlSetState($aidFileCheck[$i][2], $GUI_ENABLE) ; Button aktivieren
				GUICtrlSetBkColor($aidFileCheck[$i][0], 0x00FF00) ; und die Farbe auf grün setzen
			EndIf
		Else ; anderenfalls (Pfad existiert nicht)
			If BitAND(GUICtrlGetState($aidFileCheck[$i][2]), $GUI_ENABLE) Then ; wenn der Button aktiviert ist, dann...
				GUICtrlSetState($aidFileCheck[$i][2], $GUI_DISABLE) ; Button deaktivieren
				GUICtrlSetBkColor($aidFileCheck[$i][0], 0xFF0000) ; und die Farbe auf rot setzen
			EndIf
		EndIf
	Next
EndFunc   ;==>_CheckFileFolder

Func _ReadDatafile()
	If $iCount <> 0 Then ; wenn sich auf dem Fenster bereits Gui-Elemente befinden, dann...
		For $i = 0 To $iCount - 1 ; Schleife für die "Zeilen"
			For $j = 0 To 2 ; Schleife für die "Spalten"
				GUICtrlDelete($aidFileCheck[$i][$j]) ; alle Gui-Elemente löschen
			Next
		Next
	EndIf
	Local $sData = FileRead($sDatafile) ; Datei mit den Pfaden einlesen
	$aFileFolder = StringSplit($sData, @CRLF, 3) ; und beim Zeilenumbruch splitten
	$iCount = UBound($aFileFolder) - 1 ; Anzahl der Pfade merken
	ReDim $aidFileCheck[$iCount][3] ; das Array neu dimensionieren
	Local $aWinPos = WinGetPos($hMainGui), $aClientSize = WinGetClientSize($hMainGui) ; Position und Größe des Fensters holen
	WinMove($hMainGui, '', $aWinPos[0], $aWinPos[1], $aClientSize[0], $iCount * 40 + 56) ; das Fenster in der Größe an die neue Anzahl anpassen
	For $i = 0 To $iCount - 1 ; Schleife, um alle Pfade aus der Datendatei durchzugehen
		$aidFileCheck[$i][0] = GUICtrlCreateLabel('', 20, 24 + $i * 40, 16, 16, Default, $WS_EX_STATICEDGE) ; Label für den Status (rot/grün) erstellen
		GUICtrlSetBkColor(-1, 0xFF0000) ; erstmal auf rot setzen
		$aidFileCheck[$i][1] = GUICtrlCreateInput('', 44, 20 + $i * 40, 600, 24, BitOR($ES_LEFT, $ES_AUTOHSCROLL, $ES_READONLY)) ; das Feld für den Pfad erstellen
		GUICtrlSetBkColor(-1, 0xFFFFFF) ; Hintergrundfarbe auf weiß setzen
		GUICtrlSetFont(-1, 12, 400, 0, 'Tahoma', 5) ; Schriftart und -größe festlegen
		GUICtrlSetData(-1, $aFileFolder[$i]) ; den Pfad eintragen
		$aidFileCheck[$i][2] = GUICtrlCreateButton('', 650, 18 + $i * 40, 48, 28, $BS_ICON) ; Button zum aufrufen des Ordners erstellen
		GUICtrlSetImage(-1, 'shell32.dll', 23, 0) ; das Lupensymbol aus der Shell32.dll für den Button festlegen
		GUICtrlSetOnEvent(-1, '_OpenFolder') ; diese Funktion wird aufgerufen, wenn auf den Button geklickt wird
		GUICtrlSetState(-1, $GUI_DISABLE) ; den Button erstmal deaktivieren
		GUICtrlSetTip(-1, 'Öffne Verzeichnis im Explorer') ; den Tooltip für den Button festlegen
	Next
EndFunc   ;==>_ReadDatafile

Func _OpenFolder()
	Local $iButton = (@GUI_CtrlId - $aidFileCheck[0][2]) / 3 ; ermitteln welcher Button angeklickt wurde
	Local $sFolder
	If StringInStr(FileGetAttrib($aFileFolder[$iButton]), 'D') Then ; wenn der Pfad ein Verzeichnis ist, dann...
		$sFolder = $aFileFolder[$iButton] ; das Verzeichnis übernehmen
	Else ; anderenfalls (Pfad ist eine Datei)
		$sFolder = StringRegExpReplace($aFileFolder[$iButton], '(.+\\).*', '$1') ; das Verzeichnis aus dem Pfad extrahieren
	EndIf
	If StringRight($sFolder, 1) <> '\' Then $sFolder &= '\' ; wenn das Verzeichnis am Ende keinen Backslash aufweist, dann einen hinzufügen
	ShellExecute($sFolder) ; das Verzeichnis mit dem Explorer öffnen
EndFunc   ;==>_OpenFolder
